Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfini.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfini.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfini.F90	(revision 2236)
@@ -20,4 +20,5 @@
    USE zdftke_old      ! TKE vertical mixing  (old scheme)
    USE zdftke          ! TKE vertical mixing
+   USE zdfgls          ! GLS vertical mixing
    USE zdfkpp          ! KPP vertical mixing          
    USE zdfddm          ! double diffusion mixing      
@@ -39,5 +40,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
    
@@ -106,4 +107,8 @@
          ioptio = ioptio+1
       ENDIF
+      IF( lk_zdfgls ) THEN
+         IF(lwp) WRITE(numout,*) '      GLS dependent eddy coefficients'
+         ioptio = ioptio+1
+      ENDIF
       IF( lk_zdfkpp ) THEN
          IF(lwp) WRITE(numout,*) '      KPP dependent eddy coefficients'
@@ -128,4 +133,7 @@
          IF(lwp) WRITE(numout,*) '      use the 1.5 turbulent closure'
       ENDIF
+      IF( lk_zdfgls ) THEN
+         IF(lwp) WRITE(numout,*) '      use the GLS closure scheme'
+      ENDIF
       IF( lk_zdfkpp ) THEN
          IF(lwp) WRITE(numout,*) '      use the KPP closure scheme'
@@ -136,6 +144,6 @@
       ENDIF
       IF ( ioptio > 1 .AND. .NOT. lk_esopa )   CALL ctl_stop( ' chose between ln_zdfnpc and ln_zdfevd' )
-      IF( ioptio == 0 .AND. .NOT.( lk_zdftke_old .OR. lk_zdftke .OR. lk_zdfkpp ) ) &
-         CALL ctl_stop( ' except for TKE sor KPP physics, a convection scheme is', &
+      IF( ioptio == 0 .AND. .NOT.( lk_zdftke_old .OR. lk_zdftke .OR. lk_zdfgls .OR. lk_zdfkpp ) ) &
+         CALL ctl_stop( ' except for TKE, GLS or KPP physics, a convection scheme is', &
          &              ' required: ln_zdfevd or ln_zdfnpc logicals' )
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfkpp.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 2236)
@@ -148,5 +148,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 2236)
@@ -31,5 +31,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 2236)
@@ -46,5 +46,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 2236)
@@ -89,5 +89,5 @@
 
    REAL(wp), DIMENSION(jpi,jpj)     ::   htau      ! depth of tke penetration (nn_htau)
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   en        ! now turbulent kinetic energy   [m2/s2]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   en        ! now turbulent kinetic energy   [m2/s2]
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   dissl     ! now mixing lenght of dissipation
 
@@ -98,5 +98,5 @@
    !! NEMO/OPA 3,3 , LOCEAN-IPSL (2010) 
    !! $Id: $
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftke_old.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftke_old.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftke_old.F90	(revision 2236)
@@ -94,5 +94,5 @@
    !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftmx.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 2236)
@@ -51,5 +51,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id: $
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/greg2jul.h90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/greg2jul.h90	(revision 2236)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/greg2jul.h90	(revision 2236)
@@ -0,0 +1,89 @@
+   SUBROUTINE greg2jul( ksec, kmin, khour, kday, kmonth, kyear, pjulian, &
+      &                 krefdate )
+      !!-----------------------------------------------------------------------
+      !!
+      !!                     ***  ROUTINE greg2jul  ***
+      !!
+      !! ** Purpose : Produce the time relative to the current date and time.
+      !!
+      !! ** Method  : The units are days, so hours and minutes transform to
+      !!              fractions of a day. 
+      !!
+      !!              Reference date : 19500101
+      !! ** Action  :
+      !!
+      !! History :
+      !!      ! 06-04  (A. Vidard) Original
+      !!      ! 06-04  (A. Vidard) Reformatted
+      !!      ! 06-10  (A. Weaver) Cleanup
+      !!-----------------------------------------------------------------------
+
+      ! * Arguments
+      INTEGER, INTENT(IN) :: &
+         & ksec,   &
+         & kmin,   &
+         & khour,  & 
+         & kday,   &
+         & kmonth, & 
+         & kyear
+      REAL(KIND=dp), INTENT(OUT) :: &
+         & pjulian
+      INTEGER, INTENT(IN), OPTIONAL :: &
+         & krefdate
+
+      !! * Local declarations
+      INTEGER, PARAMETER :: &
+         & jpgreg = 15 + 31 * ( 10 + 12 * 1582 ), &     ! Gregorian calendar introduction date
+         & jporef = 2433283,                      &     ! Julian reference date: 19500101
+         & jparef = 2415021,                      &     ! Julian reference date: 19000101
+         & jpgref = 2299161                             ! Julian reference date start of Gregorian calender
+      INTEGER :: &
+         & ija,     &
+         & ijy,     &
+         & ijm,     &
+         & ijultmp, &
+         & ijyear,  &
+         & iref
+      CHARACTER(len=200) :: &
+         & cerr
+
+      IF ( PRESENT( krefdate ) ) THEN
+         SELECT CASE ( krefdate )
+
+         CASE( 0 ) 
+            iref = jpgref
+
+         CASE( 19500101 )
+            iref = jporef
+
+         CASE( 19000101 )
+            iref = jparef
+
+         CASE DEFAULT
+            WRITE(cerr,'(A,I8.8)')'greg2jul: Unknown krefdate:', krefdate
+            CALL ctl_stop( cerr )
+
+         END SELECT
+
+      ELSE
+         iref = jporef 
+      ENDIF
+
+      ! Main computation
+      ijyear = kyear
+      IF ( ijyear < 0 ) ijyear = ijyear + 1
+      IF ( kmonth > 2 ) THEN
+	 ijy = ijyear
+	 ijm = kmonth + 1
+      ELSE
+	 ijy = ijyear  - 1
+	 ijm = kmonth + 13
+      ENDIF
+      ijultmp = INT( 365.25 * ijy ) + INT( 30.6001 * ijm ) + kday + 1720995
+      IF ( kday + 31 * ( kmonth + 12 * ijyear ) >= jpgreg ) THEN
+	 ija = INT( 0.01 * ijy )
+	 ijultmp = ijultmp + 2 - ija + INT( 0.25 * ija )
+      ENDIF
+      pjulian = ( ijultmp - iref ) + ( ( 60 * khour + kmin ) * 60 + ksec ) / 86400.
+
+   END SUBROUTINE greg2jul
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/istate.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/istate.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/istate.F90	(revision 2236)
@@ -35,5 +35,4 @@
    USE in_out_manager  ! I/O manager
    USE iom             ! I/O library
-   USE c1d             ! re-initialization of u-v mask for the 1D configuration
    USE zpshde          ! partial step: hor. derivative (zps_hde routine)
    USE eosbn2          ! equation of state            (eos bn2 routine)
@@ -56,5 +55,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -128,6 +127,8 @@
          CALL tra_swap                     ! swap 3D arrays (tb,sb,tn,sn)  in a 4D array
          CALL eos( tsb, rhd, rhop )        ! before potential and in situ densities
-         IF( ln_zps .AND. .NOT. lk_c1d )   CALL zps_hde( nit000, jpts, tsb, gtsu, gtsv,  & ! zps: before hor. gradient
-            &                                                          rhd, gru , grv  )   ! of t,s,rd at ocean bottom
+#if ! defined key_c1d
+         IF( ln_zps )   CALL zps_hde( nit000, jpts, tsb, gtsu, gtsv,  & ! zps: before hor. gradient
+            &                                       rhd, gru , grv  )   ! of t,s,rd at ocean bottom
+#endif
          !   
          ! - ML - sshn could be modified by istate_eel, so that initialization of fse3t_b is done here
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/jul2greg.h90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/jul2greg.h90	(revision 2236)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/jul2greg.h90	(revision 2236)
@@ -0,0 +1,114 @@
+   RECURSIVE SUBROUTINE jul2greg( ksec, kminut, khour, kday, kmonth, kyear, &
+      &                           prelday, krefdate )
+      !!-----------------------------------------------------------------------
+      !!
+      !!                     ***  ROUTINE jul2greg  ***
+      !!
+      !! ** Purpose : Take the relative time in days and re-express in terms of
+      !!              seconds, minutes, hours, days, month, year.
+      !!
+      !! ** Method  : Reference date : 19500101
+      !!
+      !! ** Action  :
+      !!
+      !! History
+      !!      ! 06-04  (A. Vidard) Original
+      !!      ! 06-05  (A. Vidard) Reformatted and refdate      
+      !!      ! 06-10  (A. Weaver) Cleanup
+      !!-----------------------------------------------------------------------
+
+      ! * Arguments
+      INTEGER, INTENT(IN), OPTIONAL :: &
+         & krefdate
+      INTEGER, INTENT(OUT) :: &
+         & ksec,   &
+         & kminut, &
+         & khour,  &
+         & kday,   &
+         & kmonth, &
+         & kyear
+      REAL(KIND=dp), INTENT(IN) :: &
+         & prelday
+
+      !! * Local declarations
+      INTEGER, PARAMETER :: &
+         & jpgreg = 2299161, &
+         & jporef = 2433283, &
+         & jparef = 2415021
+      INTEGER :: &
+         & ijulian, &
+         & ij1,     &
+         & ija,     &
+         & ijb,     &
+         & ijc,     &
+         & ijd,     &
+         & ije,     &
+         & isec,    &
+         & imin,    &
+         & ihou,    &
+         & iday,    &
+         & imon,    &
+         & iyea,    &
+         & iref
+      REAL(KIND=wp) :: &
+         & zday, &
+         & zref
+      CHARACTER(len=200) :: &
+         & cerr
+
+      ! Main computation
+      IF ( PRESENT( krefdate ) ) THEN
+
+         SELECT CASE ( krefdate )
+
+         CASE( 0 ) 
+            iref = jpgreg
+
+         CASE( 19500101 )
+            iref = jporef
+
+         CASE( 19000101 )
+            iref = jparef
+
+         CASE DEFAULT
+            WRITE(cerr,'(A,I8.8)')'jul2greg: Unknown krefdate:', krefdate
+            CALL ctl_stop( cerr )
+
+         END SELECT
+
+      ELSE
+         iref = jporef 
+      ENDIF
+
+      zday = prelday
+      ksec = NINT( 86400. * MOD( zday, 1. ) )
+
+      IF ( ksec < 0. ) ksec = 86400. + ksec
+
+      khour  = ksec / 3600
+      kminut = ( ksec - 3600 * khour ) / 60
+      ksec   = MOD( ksec , 60 )
+
+      ijulian = iref + INT( zday )
+      IF ( zday < 0. ) ijulian = ijulian - 1
+
+      ! If input date after 10/15/1582 :
+      IF ( ijulian >= jpgreg ) THEN
+	 ij1 = INT( ( DBLE( ijulian - 1867216 ) - 0.25 ) / 36524.25 )
+	 ija = ijulian + 1 + ij1 - INT( ( 0.25 * ij1 ) )
+      ELSE
+	 ija = ijulian
+      ENDIF
+
+      ijb = ija + 1524
+      ijc = INT( 6680. + ( DBLE ( ijb - 2439870 ) - 122.1 ) / 365.25 )
+      ijd = 365 * ijc + INT( 0.25 * ijc )
+      ije = INT( ( ijb - ijd ) / 30.6001 )
+      kday = ijb - ijd - INT( 30.6001 * ije )
+      kmonth = ije - 1
+      IF ( kmonth > 12 ) kmonth = kmonth - 12
+      kyear = ijc - 4715
+      IF ( kmonth > 2 ) kyear = kyear - 1
+      IF ( kyear <= 0 ) kyear = kyear - 1
+
+   END SUBROUTINE jul2greg
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/julian.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/julian.F90	(revision 2236)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/julian.F90	(revision 2236)
@@ -0,0 +1,30 @@
+MODULE julian
+   !!======================================================================
+   !!                       ***  MODULE julian   ***
+   !! Ocean          : Julian data utilities
+   !!=====================================================================
+
+   !!----------------------------------------------------------------------
+   !!   jul2greg        : Convert relative time to date
+   !!   greg2jul        : Convert date to relative time
+   !!----------------------------------------------------------------------
+   !! * Modules used
+   USE par_kind, ONLY : &       ! Precision variables
+      & wp, &
+      & dp  
+   USE in_out_manager           ! I/O manager
+  
+   IMPLICIT NONE
+
+   !! * Routine accessibility
+   PRIVATE
+   PUBLIC jul2greg,        &  ! Convert relative time to date
+      &   greg2jul            ! Convert date to relative time 
+  
+CONTAINS
+ 
+#include "jul2greg.h90"
+
+#include "greg2jul.h90"
+   
+END MODULE julian
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/lib_mpp.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/lib_mpp.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/lib_mpp.F90	(revision 2236)
@@ -71,7 +71,5 @@
    PUBLIC   mpprecv, mppsend, mppscatter, mppgather
    PUBLIC   mppobc, mpp_ini_ice, mpp_ini_znl
-#if defined key_oasis3 || defined key_oasis4
    PUBLIC   mppsize, mpprank
-#endif
 
 # if defined key_mpp_rep1
@@ -176,5 +174,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/oce.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/oce.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/oce.F90	(revision 2236)
@@ -48,5 +48,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!======================================================================
 END MODULE oce
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/opa.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/opa.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/opa.F90	(revision 2236)
@@ -25,5 +25,6 @@
    !!             -   ! 2007-07  (J. Chanut, A. Sellar) Unstructured open boundaries (BDY)
    !!            3.2  ! 2009-08  (S. Masson)  open/write in the listing file in mpp
-   !!            3.3  ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
+   !!            3.3  ! 2010-05  (K. Mogensen, A. Weaver, M. Martin, D. Lea) Assimilation interface 
+   !!             -   ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!----------------------------------------------------------------------
 
@@ -47,4 +48,10 @@
    USE zdfini
    USE phycst          ! physical constant                  (par_cst routine)
+   USE trdmod          ! momentum/tracers trends       (trd_mod_init routine)
+   USE asminc          ! assimilation increments       (asm_inc_init routine)
+   USE asmtrj          ! writing out state trajectory
+   USE sshwzv          ! vertical velocity used in asm
+   USE diaptr          ! poleward transports           (dia_ptr_init routine)
+   USE diaobs          ! Observation diagnostics       (dia_obs_init routine)
    USE step            ! OPA time-stepping                  (stp     routine)
 #if defined key_oasis3
@@ -53,6 +60,8 @@
    USE cpl_oasis4      ! OASIS4 coupling (not working)
 #endif
+#if defined key_c1d
    USE c1d             ! 1D configuration
    USE step_c1d        ! Time stepping loop for the 1D configuration
+#endif
 #if defined key_top
    USE trcini          ! passive tracer initialisation
@@ -74,5 +83,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -114,10 +123,23 @@
       !                            !-----------------------!
       istp = nit000
-      IF( lk_c1d ) THEN                 !==  1D configuration  ==!
+#if defined key_c1d
          DO WHILE ( istp <= nitend .AND. nstop == 0 )
             CALL stp_c1d( istp )
             istp = istp + 1
          END DO
-      ELSE                              !==  3D ocean with  ==!
+#else
+          IF( lk_asminc ) THEN
+             IF( ln_bkgwri ) CALL asm_bkg_wri( nit000 - 1 )    ! Output background fields
+             IF( ln_trjwri ) CALL asm_trj_wri( nit000 - 1 )    ! Output trajectory fields
+             IF( ln_asmdin ) THEN                        ! Direct initialization
+                IF( ln_trainc ) CALL tra_asm_inc( nit000 - 1 )    ! Tracers
+                IF( ln_dyninc ) THEN 
+                   CALL dyn_asm_inc( nit000 - 1 )    ! Dynamics
+                   IF ( ln_asmdin ) CALL ssh_wzv ( nit000 - 1 )      ! update vertical velocity 
+                ENDIF
+                IF( ln_sshinc ) CALL ssh_asm_inc( nit000 - 1 )    ! SSH
+             ENDIF
+          ENDIF
+        
          DO WHILE ( istp <= nitend .AND. nstop == 0 )
 #if defined key_agrif
@@ -129,5 +151,7 @@
             IF( lk_mpp )   CALL mpp_max( nstop )
          END DO
-      ENDIF
+#endif
+
+      IF( lk_diaobs ) CALL dia_obs_wri
        
       !                            !------------------------!
@@ -184,5 +208,7 @@
 #else
 # if defined key_oasis3 || defined key_oasis4
-      CALL cpl_prism_init( ilocal_comm )      ! nemo local communicator given by oasis
+      IF( Agrif_Root() ) THEN
+         CALL cpl_prism_init( ilocal_comm )      ! nemo local communicator given by oasis
+      ENDIF
       narea = mynode( cltxt, ilocal_comm )    ! Nodes selection (control print return in cltxt)
 # else
@@ -222,4 +248,11 @@
       ELSE                            ;   CALL mpp_init2     ! eliminate land processors
       ENDIF
+!!gm c1d case can be moved in dom_init routine
+#if defined key_c1d
+         CALL cor_c1d                            ! Coriolis defined at T-point
+         umask(:,:,:) = tmask(:,:,:)             ! U, V and T-points are the same
+         vmask(:,:,:) = tmask(:,:,:)             ! 
+#endif
+!!gm c1d end
 
       !                                      ! General initialization
@@ -282,4 +315,11 @@
                             CALL dia_hsb_init   ! heat content, salt content and volume budgets
                             CALL trd_mod_init   ! Mixed-layer/Vorticity/Integral constraints trends
+      IF( lk_diaobs    ) THEN
+         CALL dia_obs_init                  ! Initialize observational data
+         CALL dia_obs( nit000 - 1 )         ! Observation operator for restart
+      ENDIF      
+      IF( lk_asminc    )    CALL asm_inc_init     ! Initialize assimilation increments
+      IF(lwp) WRITE(numout,*)'Euler time step switch is ', neuler
+
       !
    END SUBROUTINE opa_init
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/par_oce.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/par_oce.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/par_oce.F90	(revision 2236)
@@ -18,7 +18,21 @@
    !! if we dont use massively parallel computer (parameters jpni=jpnj=1) so jpiglo=jpi and jpjglo=jpj
 #if ! defined key_mpp_dyndist 
-   INTEGER, PUBLIC, PARAMETER ::   jpni   = 1   !: number of processors following i 
-   INTEGER, PUBLIC, PARAMETER ::   jpnj   = 1   !: number of processors following j
-   INTEGER, PUBLIC, PARAMETER ::   jpnij  = 1   !: nb of local domain = nb of processors ( <= jpni x jpnj )
+   INTEGER, PUBLIC, PARAMETER ::    &  !:
+# if ! defined key_nproci
+      jpni   = 1,                   &  !: number of processors following i
+      jpnj   = 1,                   &  !: number of processors following j
+      jpnij  = 1                       !: nb of local domain = nb of processors 
+      !                                !  ( <= jpni x jpnj )
+# else
+      jpni   = key_nproci,          &  !: number of processors following i
+      jpnj   = key_nprocj,          &  !: number of processors following j
+#  if ! defined key_nprocij
+      jpnij  = key_nproci * key_nprocj !: nb of local domain = nb of processors 
+      !                                !  ( <= jpni x jpnj )
+#  else
+      jpnij  = key_nprocij             !: nb of local domain = nb of processors 
+      !                                !  ( <= jpni x jpnj )
+#  endif
+# endif
 #else
    INTEGER, PUBLIC            ::   jpni         !: number of processors following i 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step.F90	(revision 2236)
@@ -21,5 +21,6 @@
    !!            3.2  !  2009-02  (G. Madec, R. Benshila)  reintroduicing z*-coordinate
    !!             -   !  2009-06  (S. Masson, G. Madec)  TKE restart compatible with key_cpl
-   !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase + merge TRC-TRA
+   !!            3.3  !  2010-05  (K. Mogensen, A. Weaver, M. Martin, D. Lea) Assimilation interface
+   !!             -   !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase + merge TRC-TRA
    !!----------------------------------------------------------------------
 
@@ -32,4 +33,13 @@
 #endif
 
+   USE asminc          ! assimilation increments    (tra_asm_inc, dyn_asm_inc routines)
+   USE stpctl          ! time stepping control            (stp_ctl routine)
+   USE restart         ! ocean restart                    (rst_wri routine)
+   USE prtctl          ! Print control                    (prt_ctl routine)
+
+#if defined key_agrif
+   USE agrif_opa_sponge ! Momemtum and tracers sponges
+#endif
+
    IMPLICIT NONE
    PRIVATE
@@ -43,5 +53,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
@@ -112,4 +122,5 @@
       IF( lk_zdftke_old )   CALL zdf_tke_old( kstp )  ! TKE closure scheme for Kz (old scheme)
       IF( lk_zdftke     )   CALL zdf_tke    ( kstp )  ! TKE closure scheme for Kz
+      IF( lk_zdfgls     )   CALL zdf_gls    ( kstp )  ! GLS closure scheme for Kz
       IF( lk_zdfkpp     )   CALL zdf_kpp    ( kstp )  ! KPP closure scheme for Kz
       IF( lk_zdfcst     )   THEN                      ! Constant Kz (reset avt, avm[uv] to the background value)
@@ -131,4 +142,6 @@
                                                       ! write tke information in the restart file
       IF( lrst_oce .AND. lk_zdftke )   CALL tke_rst( kstp, 'WRITE' )
+                                                      ! write gls information in the restart file
+      IF( lrst_oce .AND. lk_zdfgls )   CALL gls_rst( kstp, 'WRITE' )
       !
       !  LATERAL  PHYSICS 
@@ -138,5 +151,10 @@
          IF( ln_zps )    CALL zps_hde( kstp, jpts, tsb, gtsu, gtsv,  &    ! Partial steps: before horizontal gradient
             &                                      rhd, gru , grv  )      ! of t, s, rd at the last ocean level
+         IF ( .NOT. ln_traldf_grif ) THEN
                          CALL ldf_slp( kstp, rhd, rn2b )        ! before slope of the lateral mixing
+         ELSE
+                         CALL ldf_slp_grif( kstp )
+                         IF ( ln_dynldf_bilap .OR. ln_dynldf_iso ) CALL ldf_slp( kstp, rhd, rn2b )
+      ENDIF
       ENDIF
 #if defined key_traldf_c2d
@@ -152,4 +170,5 @@
       IF( lk_diahdy  )   CALL dia_hdy( kstp )         ! dynamical heigh diagnostics
       IF( lk_diafwb  )   CALL dia_fwb( kstp )         ! Fresh water budget diagnostics
+      IF( lk_diaobs  )   CALL dia_obs( kstp )         ! obs-minus-model (assimilation) diagnostics
       IF( ln_diaptr  )   CALL dia_ptr( kstp )         ! Poleward TRansports diagnostics
       IF( lk_diaar5  )   CALL dia_ar5( kstp )         ! ar5 diag
@@ -168,4 +187,6 @@
                              tsa(:,:,:,:) = 0.e0               ! set tracer trends to zero
 
+      IF(  ln_asmiau .AND. &
+         & ln_trainc     )   CALL tra_asm_inc( kstp )       ! apply tracer assimilation increment
                              CALL tra_sbc    ( kstp )       ! surface boundary condition
       IF( ln_traqsr      )   CALL tra_qsr    ( kstp )       ! penetrative solar radiation qsr
@@ -206,4 +227,6 @@
                                va(:,:,:) = 0.e0
 
+      IF(  ln_asmiau .AND. &
+         & ln_dyninc     )     CALL dyn_asm_inc( kstp )       ! apply dynamics assimilation increment
                                CALL dyn_adv( kstp )         ! advection (vector or flux form)
                                CALL dyn_vor( kstp )         ! vorticity term including Coriolis
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/stpctl.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/stpctl.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/stpctl.F90	(revision 2236)
@@ -29,5 +29,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/trc_oce.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/trc_oce.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/trc_oce.F90	(revision 2236)
@@ -40,5 +40,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
